#1087 URL with IPv6 numeric address can't be accessed

closed-fixed
libcurl (356)
5
2014-08-25
2012-01-31
zooloo
No

My test set has eth0/1 interfaces configured on different IPv6 subnets
Test client uses curl to access IPv6 in different from it's own subnet trough proxy.

When trying to access URL like https:://[fc00:1:2::5:6:b]:8443/testsrv/index.php

All addresses and URLs - are my local internal use services, but it seems like problem is not related to exact service or privoxy configuration

[root@sh5 ~]# curl -v -g -k "https://[fc00:1:2::5:6:b]:8443/enterprise/control/agent.php"
* About to connect() to proxy 105.168.1.1 port 8008
* Trying 105.168.1.1... connected
* Connected to 105.168.1.1 (105.168.1.1) port 8008
* Establish HTTP proxy tunnel to fc00:1:2::5:6:b:8443
> CONNECT fc00:1:2::5:6:b:8443 HTTP/1.0
> Host: fc00:1:2::5:6:b:8443
> User-Agent: curl/7.15.5 (x86_64-redhat-linux-gnu) libcurl/7.15.5 OpenSSL/0.9.8b zlib/1.2.3 libidn/0.6.5
> Proxy-Connection: Keep-Alive
>
< HTTP/1.0 404 No such domain
< Content-Length: 7377
< Content-Type: text/html
< Cache-Control: no-cache
< Date: Mon, 30 Jan 2012 11:06:06 GMT
< Last-Modified: Wed, 08 Jun 1955 12:00:00 GMT
< Expires: Sat, 17 Jun 2000 12:00:00 GMT
< Pragma: no-cache
< Connection: close
<
* Received HTTP code 404 from proxy after CONNECT
* Closing connection #0
curl: (56) Received HTTP code 404 from proxy after CONNECT

I'm using:

curl --version
curl 7.15.5 (x86_64-redhat-linux-gnu) libcurl/7.15.5 OpenSSL/0.9.8b zlib/1.2.3 libidn/0.6.5
Protocols: tftp ftp telnet dict ldap http file https ftps
Features: GSS-Negotiate IDN IPv6 Largefile NTLM SSL libz

Discussion

  • zooloo

    zooloo - 2012-01-31

    privoxy logfile

     
  • zooloo

    zooloo - 2012-01-31

    Look like curl have to add [] into outgoing message but it have to be sure the given host name - is a numeric IPv6 address

     
  • Dan Fandrich

    Dan Fandrich - 2012-01-31

    7.15.5 is ancient history. Does it happen in a more recent version? I can't reproduce it in 7.24.0 (at least with a http URL).

     
  • Dan Fandrich

    Dan Fandrich - 2012-01-31

    I just tried it with an SSL-enabled version of 7.24.0 and it fails there, too, but only on https: URLs; plain http: works fine. Both the CONNECT and the Host: lines are missing the square brackets. Looks like a bona-fide bug to me.

     
  • Daniel Stenberg

    Daniel Stenberg - 2012-01-31

    See my suggested patch that I attached here that seems to fix the problem for me!

     
  • zooloo

    zooloo - 2012-02-01

    For 7.24.0 patch looks well.
    Seems it did help me. Thanks.

     
  • Daniel Stenberg

    Daniel Stenberg - 2012-02-01
    • status: open --> closed-fixed
     

Get latest updates about Open Source Projects, Conferences and News.

Sign up for the SourceForge newsletter:





No, thanks